#include    <stdio.h>
#ifdef _DCC
#include    <exec/types.h>
#include    <exec/io.h>
#include    <exec/devices.h>
#endif
#ifdef QDOS
char _prog_name[] = "picoEmacs";
#include    <qdos.h>
#include    <qptr.h>
#ifdef BBS
extern char eolcode;
#endif
#endif

#include    "ed.h"

extern  int     ttopen();               /* Forward references.          */
extern  int     ttgetc();
extern  int     ttputc();
extern  int     ttflush();
extern  int     ttclose();
extern  int     ttmove();
extern  int     tteeol();
extern  int     tteeop();
extern  int     ttbeep();
extern  int ttputs(char *s);

/*
 * Standard terminal interface dispatch table.  Most terminal functions
 * in this module, some in "termio".
 */
TERM term    = {
        22,
        80,
        ttopen,
        ttclose,
        ttgetc,
        ttputc,
        ttflush,
        ttmove,
        tteeol,
        tteeop,
        ttbeep,
        ttputs
};

#ifdef _DCC
static void CookIt (void)
{
    SetMode (fdtofh (fileno (stdin)), 0);
}
#endif
ttopen()
{
    setvbuf (stdin, NULL, _IONBF, 0);
    setvbuf (stdout, NULL, _IONBF, 0);
#ifdef _DCC
    atexit (CookIt);
    SetMode (fdtofh (fileno (stdin)), 1);
#endif
}
ttclose()
{
    tteeop();
}       

ttputs(char *s)
{
    fputs(s, stdout);
}

ttgetc()
{
#ifndef QDOS
    int c;

    if((c = getchar()) == EOF)
    {
        exit(0);
    }
    else
    {
        return c;
    }
#else
    char c;
    /*
        added timeout to eof as methods of exiting, some QL ser ports dont
        support carrier detect ;-(
        also added code to ignore lf from received cr/lf pairs
    */
 while(1)
 {
    if(io_fbyte(fgetchid(stdin),5*3000,&c) != 0)
    {
        exit(-1);
    }
#ifdef BBS
    else
    {
      if (c != '\n')            /* if not lf, return whatever you got */
         return (int)c;
      if (eolcode == '\n')      /* if you got a line feed and eol is lf, */
          return (int)'\r';     /* return it as cr which is normal eol   */
                                /* else ignore lf and get another char   */
    }
#else
    return (int)c;
#endif
 }
#endif
}

ttputc(int c)
{
    putchar(c);
#ifdef BBS
    if (c == '\r')
       putchar('\n');           /* always send cr/lf if used in a bbs */
#endif
}

ttflush()
{
}

ttmove(row, col)
int row, col;
{
   printf("\033[%d;%dH", row+1, col+1);
}

tteeol()
{
   fputs("\033[0K", stdout);
}

tteeop()
{
    fputs("\033[0K\033[0J", stdout);
}

ttbeep()
{
   putchar('\a');
}
